Index: serefpolicy-contrib-20140730/rhcs.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rhcs.if
+++ serefpolicy-contrib-20140730/rhcs.if
@@ -1,19 +1,19 @@
-## <summary>Red Hat Cluster Suite.</summary>
+## <summary>RHCS - Red Hat Cluster Suite</summary>
 
 #######################################
 ## <summary>
-##	The template to define a rhcs domain.
+##	Creates types and rules for a basic
+##	rhcs init daemon domain.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix for the domain.
 ##	</summary>
 ## </param>
 #
 template(`rhcs_domain_template',`
 	gen_require(`
-		attribute cluster_domain, cluster_pid, cluster_tmpfs;
-		attribute cluster_log;
+		attribute cluster_domain, cluster_tmpfs, cluster_pid, cluster_log;
 	')
 
 	##############################
@@ -43,33 +43,27 @@ template(`rhcs_domain_template',`
 	manage_files_pattern($1_t, $1_tmpfs_t, $1_tmpfs_t)
 	fs_tmpfs_filetrans($1_t, $1_tmpfs_t, { dir file })
 
-	manage_dirs_pattern($1_t, $1_var_log_t, $1_var_log_t)
-	append_files_pattern($1_t, $1_var_log_t, $1_var_log_t)
-	create_files_pattern($1_t, $1_var_log_t, $1_var_log_t)
-	setattr_files_pattern($1_t, $1_var_log_t, $1_var_log_t)
-	manage_sock_files_pattern($1_t, $1_var_log_t, $1_var_log_t)
 	logging_log_filetrans($1_t, $1_var_log_t, { dir file sock_file })
 
 	manage_dirs_pattern($1_t, $1_var_run_t, $1_var_run_t)
 	manage_files_pattern($1_t, $1_var_run_t, $1_var_run_t)
 	manage_fifo_files_pattern($1_t, $1_var_run_t, $1_var_run_t)
 	manage_sock_files_pattern($1_t, $1_var_run_t, $1_var_run_t)
-	files_pid_filetrans($1_t, $1_var_run_t, { dir file sock_file fifo_file })
+	files_pid_filetrans($1_t, $1_var_run_t, { file sock_file fifo_file })
 
-	optional_policy(`
-		dbus_system_bus_client($1_t)
-	')
+	auth_use_nsswitch($1_t)
+
+	logging_send_syslog_msg($1_t)
 ')
 
 ######################################
 ## <summary>
-##	Execute a domain transition to
-##	run dlm_controld.
+##	Execute a domain transition to run dlm_controld.
 ## </summary>
 ## <param name="domain">
-## <summary>
+##	<summary>
 ##	Domain allowed to transition.
-## </summary>
+##	</summary>
 ## </param>
 #
 interface(`rhcs_domtrans_dlm_controld',`
@@ -83,27 +77,8 @@ interface(`rhcs_domtrans_dlm_controld',`
 
 #####################################
 ## <summary>
-##	Get attributes of fenced
-##	executable files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`rhcs_getattr_fenced_exec_files',`
-	gen_require(`
-		type fenced_exec_t;
-	')
-
-	allow $1 fenced_exec_t:file getattr_file_perms;
-')
-
-#####################################
-## <summary>
-##	Connect to dlm_controld with a
-##	unix domain stream socket.
+##	Connect to dlm_controld over a unix domain
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -122,7 +97,7 @@ interface(`rhcs_stream_connect_dlm_contr
 
 #####################################
 ## <summary>
-##	Read and write dlm_controld semaphores.
+##	Allow read and write access to dlm_controld semaphores.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -160,9 +135,27 @@ interface(`rhcs_domtrans_fenced',`
 	domtrans_pattern($1, fenced_exec_t, fenced_t)
 ')
 
+#####################################
+## <summary>
+##  Allow a domain to getattr on fenced executable.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`rhcs_getattr_fenced',`
+    gen_require(`
+        type fenced_t, fenced_exec_t;
+    ')
+
+	allow $1 fenced_exec_t:file getattr;
+')
+
 ######################################
 ## <summary>
-##	Read and write fenced semaphores.
+##	Allow read and write access to fenced semaphores.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -181,10 +174,9 @@ interface(`rhcs_rw_fenced_semaphores',`
 	manage_files_pattern($1, fenced_tmpfs_t, fenced_tmpfs_t)
 ')
 
-####################################
+######################################
 ## <summary>
-##	Connect to all cluster domains
-##	with a unix domain stream socket.
+##	Read fenced PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -192,19 +184,18 @@ interface(`rhcs_rw_fenced_semaphores',`
 ##	</summary>
 ## </param>
 #
-interface(`rhcs_stream_connect_cluster',`
+interface(`rhcs_read_fenced_pid_files',`
 	gen_require(`
-		attribute cluster_domain, cluster_pid;
+		type fenced_var_run_t;
 	')
 
 	files_search_pids($1)
-	stream_connect_pattern($1, cluster_pid, cluster_pid, cluster_domain)
+	read_files_pattern($1, fenced_var_run_t, fenced_var_run_t)
 ')
 
 ######################################
 ## <summary>
-##	Connect to fenced with an unix
-##	domain stream socket.
+##	Connect to fenced over a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -221,10 +212,28 @@ interface(`rhcs_stream_connect_fenced',`
 	stream_connect_pattern($1, fenced_var_run_t, fenced_var_run_t, fenced_t)
 ')
 
+######################################
+## <summary>
+##	Execute a domain transition to run fenced.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`rhcs_domtrans_haproxy',`
+	gen_require(`
+		type haproxy_t, haproxy_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, haproxy_exec_t, haproxy_t)
+')
+
 #####################################
 ## <summary>
-##	Execute a domain transition
-##	to run gfs_controld.
+##	Execute a domain transition to run gfs_controld.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -243,7 +252,7 @@ interface(`rhcs_domtrans_gfs_controld',`
 
 ####################################
 ## <summary>
-##	Read and write gfs_controld semaphores.
+##	Allow read and write access to gfs_controld semaphores.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -264,7 +273,7 @@ interface(`rhcs_rw_gfs_controld_semaphor
 
 ########################################
 ## <summary>
-##	Read and write gfs_controld_t shared memory.
+##	Read and write to gfs_controld_t shared memory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -285,8 +294,7 @@ interface(`rhcs_rw_gfs_controld_shm',`
 
 #####################################
 ## <summary>
-##	Connect to gfs_controld_t with
-##	a unix domain stream socket.
+##	Connect to gfs_controld_t over a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -324,8 +332,8 @@ interface(`rhcs_domtrans_groupd',`
 
 #####################################
 ## <summary>
-##	Connect to groupd with a unix
-##	domain stream socket.
+##	Connect to groupd over a unix domain
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -342,10 +350,51 @@ interface(`rhcs_stream_connect_groupd',`
 	stream_connect_pattern($1, groupd_var_run_t, groupd_var_run_t, groupd_t)
 ')
 
+#####################################
+## <summary>
+##	Allow read and write access to groupd semaphores.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rhcs_rw_groupd_semaphores',`
+	gen_require(`
+		type groupd_t, groupd_tmpfs_t;
+	')
+
+	allow $1 groupd_t:sem { rw_sem_perms destroy };
+
+	fs_search_tmpfs($1)
+	manage_files_pattern($1, groupd_tmpfs_t, groupd_tmpfs_t)
+')
+
 ########################################
 ## <summary>
-##	Read and write all cluster domains
-##	shared memory.
+##	Read and write to group shared memory.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rhcs_rw_groupd_shm',`
+	gen_require(`
+		type groupd_t, groupd_tmpfs_t;
+	')
+
+	allow $1 groupd_t:shm { rw_shm_perms destroy };
+
+	fs_search_tmpfs($1)
+	manage_files_pattern($1, groupd_tmpfs_t, groupd_tmpfs_t)
+')
+
+########################################
+## <summary>
+##	Read and write to group shared memory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -366,8 +415,7 @@ interface(`rhcs_rw_cluster_shm',`
 
 ####################################
 ## <summary>
-##	Read and write all cluster
-##	domains semaphores.
+##	Read and write access to cluster domains semaphores.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -383,9 +431,10 @@ interface(`rhcs_rw_cluster_semaphores',`
 	allow $1 cluster_domain:sem { rw_sem_perms destroy };
 ')
 
-#####################################
+####################################
 ## <summary>
-##	Read and write groupd semaphores.
+##	Connect to cluster domains over a unix domain
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -393,20 +442,44 @@ interface(`rhcs_rw_cluster_semaphores',`
 ##	</summary>
 ## </param>
 #
-interface(`rhcs_rw_groupd_semaphores',`
+interface(`rhcs_stream_connect_cluster',`
 	gen_require(`
-		type groupd_t, groupd_tmpfs_t;
+		attribute cluster_domain, cluster_pid;
 	')
 
-	allow $1 groupd_t:sem { rw_sem_perms destroy };
+	files_search_pids($1)
+	stream_connect_pattern($1, cluster_pid, cluster_pid, cluster_domain)
+')
 
-	fs_search_tmpfs($1)
-	manage_files_pattern($1, groupd_tmpfs_t, groupd_tmpfs_t)
+#####################################
+## <summary>
+##	Connect to cluster domains over a unix domain
+##	stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rhcs_stream_connect_cluster_to',`
+	gen_require(`
+		attribute cluster_domain;
+		attribute cluster_pid;
+	')
+
+    files_search_pids($1)
+    stream_connect_pattern($1, cluster_pid, cluster_pid, $2)
 ')
 
 ########################################
 ## <summary>
-##	Read and write groupd shared memory.
+##	Send a null signal to cluster.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -414,15 +487,12 @@ interface(`rhcs_rw_groupd_semaphores',`
 ##	</summary>
 ## </param>
 #
-interface(`rhcs_rw_groupd_shm',`
+interface(`rhcs_signull_cluster',`
 	gen_require(`
-		type groupd_t, groupd_tmpfs_t;
+		type cluster_t;
 	')
 
-	allow $1 groupd_t:shm { rw_shm_perms destroy };
-
-	fs_search_tmpfs($1)
-	manage_files_pattern($1, groupd_tmpfs_t, groupd_tmpfs_t)
+	allow $1 cluster_t:process signull;
 ')
 
 ######################################
@@ -446,52 +516,361 @@ interface(`rhcs_domtrans_qdiskd',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an rhcs environment.
+##	Allow domain to read qdiskd tmpfs files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`rhcs_read_qdiskd_tmpfs_files',`
+	gen_require(`
+		type qdiskd_tmpfs_t;
+	')
+
+	fs_search_tmpfs($1)
+	allow $1 qdiskd_tmpfs_t:file read_file_perms;
+')
+
+######################################
+## <summary>
+##	Allow domain to read cluster lib files
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`rhcs_admin',`
+interface(`rhcs_read_cluster_lib_files',`
 	gen_require(`
-		attribute cluster_domain, cluster_pid, cluster_tmpfs;
-		attribute cluster_log;
-		type dlm_controld_initrc_exec_t, foghorn_initrc_exec_t, fenced_lock_t;
-		type fenced_tmp_t, qdiskd_var_lib_t;
+		type cluster_var_lib_t;
 	')
 
-	allow $1 cluster_domain:process { ptrace signal_perms };
-	ps_process_pattern($1, cluster_domain)
+	files_search_var_lib($1)
+	read_files_pattern($1, cluster_var_lib_t, cluster_var_lib_t)
+')
 
-	init_labeled_script_domtrans($1, { dlm_controld_initrc_exec_t foghorn_initrc_exec_t })
-	domain_system_change_exemption($1)
-	role_transition $2 { dlm_controld_initrc_exec_t foghorn_initrc_exec_t } system_r;
-	allow $2 system_r;
+#####################################
+## <summary>
+##  Allow domain to manage cluster lib files
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_manage_cluster_lib_files',`
+    gen_require(`
+        type cluster_var_lib_t;
+    ')
 
-	files_search_pids($1)
-	admin_pattern($1, cluster_pid)
+    files_search_var_lib($1)
+    manage_files_pattern($1, cluster_var_lib_t, cluster_var_lib_t)
+')
 
-	files_search_locks($1)
-	admin_pattern($1, fenced_lock_t)
+####################################
+## <summary>
+##  Allow domain to relabel cluster lib files
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_relabel_cluster_lib_files',`
+    gen_require(`
+        type cluster_var_lib_t;
+    ')
 
-	files_search_tmp($1)
-	admin_pattern($1, fenced_tmp_t)
+    files_search_var_lib($1)
+    relabelto_files_pattern($1, cluster_var_lib_t, cluster_var_lib_t)
+	relabelfrom_files_pattern($1, cluster_var_lib_t, cluster_var_lib_t)
+')
 
-	files_search_var_lib($1)
-	admin_pattern($1, qdiskd_var_lib_t)
+######################################
+## <summary>
+##  Execute a domain transition to run cluster administrative domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`rhcs_domtrans_cluster',`
+    gen_require(`
+        type cluster_t, cluster_exec_t;
+    ')
 
-	fs_search_tmpfs($1)
-	admin_pattern($1, cluster_tmpfs)
+    corecmd_search_bin($1)
+    domtrans_pattern($1, cluster_exec_t, cluster_t)
+')
+
+#######################################
+## <summary>
+##  Execute cluster init scripts in
+##  the init script domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`rhcs_initrc_domtrans_cluster',`
+    gen_require(`
+        type cluster_initrc_exec_t;
+    ')
+
+    init_labeled_script_domtrans($1, cluster_initrc_exec_t)
+')
+
+#####################################
+## <summary>
+##  Execute cluster in the caller domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_exec_cluster',`
+    gen_require(`
+        type cluster_exec_t;
+    ')
+
+    corecmd_search_bin($1)
+    can_exec($1, cluster_exec_t)
+')
+
+######################################
+## <summary>
+##  Read cluster log files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_read_log_cluster',`
+    gen_require(`
+        type cluster_var_log_t;
+    ')
+
+    logging_search_logs($1)
+    list_dirs_pattern($1, cluster_var_log_t, cluster_var_log_t)
+    read_files_pattern($1, cluster_var_log_t, cluster_var_log_t)
+')
+
+######################################
+## <summary>
+##  Setattr cluster log files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_setattr_log_cluster',`
+    gen_require(`
+        type cluster_var_log_t;
+    ')
+
+    setattr_files_pattern($1, cluster_var_log_t, cluster_var_log_t)
+')
+
+#####################################
+## <summary>
+##  Allow the specified domain to read/write inherited cluster's tmpf files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_rw_inherited_cluster_tmp_files',`
+    gen_require(`
+        type cluster_tmp_t;
+    ')
+
+    allow $1 cluster_tmp_t:file rw_inherited_file_perms;
+')
+
+#####################################
+## <summary>
+##  Allow manage cluster tmp files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_manage_cluster_tmp_files',`
+    gen_require(`
+        type cluster_tmp_t;
+    ')
 
-	logging_search_logs($1)
-	admin_pattern($1, cluster_log)
+    files_search_tmp($1)
+    manage_files_pattern($1, cluster_tmp_t, cluster_tmp_t)
+')
+
+#####################################
+## <summary>
+##  Allow the specified domain to read/write cluster's tmpfs files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_rw_cluster_tmpfs',`
+    gen_require(`
+        type cluster_tmpfs_t;
+    ')
+
+    rw_files_pattern($1, cluster_tmpfs_t, cluster_tmpfs_t)
+    delete_files_pattern($1, cluster_tmpfs_t, cluster_tmpfs_t)
+')
+
+#####################################
+## <summary>
+##  Allow manage cluster tmpfs files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_manage_cluster_tmpfs_files',`
+    gen_require(`
+        type cluster_tmpfs_t;
+    ')
+
+    fs_search_tmpfs($1)
+    manage_files_pattern($1, cluster_tmpfs_t, cluster_tmpfs_t)
+')
+
+#####################################
+## <summary>
+##  Allow read cluster pid files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_read_cluster_pid_files',`
+       gen_require(`
+               type cluster_var_run_t;
+       ')
+
+       files_search_pids($1)
+       read_files_pattern($1, cluster_var_run_t, cluster_var_run_t)
+')
+
+
+#####################################
+## <summary>
+##  Allow manage cluster pid files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhcs_manage_cluster_pid_files',`
+       gen_require(`
+               type cluster_var_run_t;
+       ')
+
+       files_search_pids($1)
+       manage_files_pattern($1, cluster_var_run_t, cluster_var_run_t)
+')
+
+#######################################
+## <summary>
+##  Execute cluster server in the cluster domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`rhcs_systemctl_cluster',`
+    gen_require(`
+        type cluster_t;
+        type cluster_unit_file_t;
+    ')
+
+    systemd_exec_systemctl($1)
+    allow $1 cluster_unit_file_t:file read_file_perms;
+    allow $1 cluster_unit_file_t:service manage_service_perms;
+
+    ps_process_pattern($1, cluster_t)
+')
+
+#####################################
+## <summary>
+##  All of the rules required to administrate
+##  an cluster environment
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+## <param name="role">
+##  <summary>
+##  The role to be allowed to manage the rgmanager domain.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+interface(`rhcs_admin_cluster',`
+    gen_require(`
+        type cluster_t, cluster_initrc_exec_t, cluster_tmp_t;
+        type cluster_tmpfs_t, cluster_var_log_t, cluster_var_run_t;
+		type cluster_unit_file_t;
+    ')
+
+    allow $1 cluster_t:process signal_perms;
+    ps_process_pattern($1, cluster_t)
+
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 cluster_t:process ptrace;
+    ')
+
+    init_labeled_script_domtrans($1, cluster_initrc_exec_t)
+    domain_system_change_exemption($1)
+    role_transition $2 cluster_initrc_exec_t system_r;
+    allow $2 system_r;
+
+    files_list_tmp($1)
+    admin_pattern($1, cluster_tmp_t)
+
+    admin_pattern($1, cluster_tmpfs_t)
+
+    logging_list_logs($1)
+    admin_pattern($1, cluster_var_log_t)
+
+    files_list_pids($1)
+    admin_pattern($1, cluster_var_run_t)
+
+    rhcs_systemctl_cluster($1)
+    admin_pattern($1, cluster_unit_file_t)
+    allow $1 cluster_unit_file_t:service all_service_perms;
 ')
